using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace TemplateApp
{
	/// <summary>
	/// Summary description for WebForm1.
	/// </summary>
	public class WebForm1 : TemplateApp.Templates.PageTemplate
	{
		protected System.Web.UI.WebControls.DataGrid DataGrid1;
		private System.Data.DataTable myTable;

		private void Page_Load(object sender, System.EventArgs e)
		{
			if (!Page.IsPostBack)
			{
				this.Title = "Ambrose Test";
				this.StyleSheet = "myCss.css";
				ViewState["DataGrid1Sort"] = "Name ASC";
				this.BindGrid();
			}
		}

		private void BindGrid()
		{
			this.LoadTable();
			this.DataGrid1.DataSource = this.myTable.DefaultView;
			this.DataGrid1.DataBind();
		}

		private void LoadTable()
		{
			DataRow row;
			this.myTable = new DataTable();
      this.myTable.Columns.Add(new DataColumn("Name", typeof(System.String)));
			this.myTable.Columns.Add(new DataColumn("Age", typeof(System.Int32)));
			this.myTable.Columns.Add(new DataColumn("DOB", typeof(System.DateTime)));
			for (int i = 0; i < 10; i++)
			{
				row = this.myTable.NewRow();
				row["Name"] = "Johnny Q" + i.ToString();
				row["Age"] = (i+20);
				row["DOB"] = System.DateTime.Today.AddYears(-(i+20));
				this.myTable.Rows.Add(row);
			}
			this.myTable.DefaultView.Sort = ViewState["DataGrid1Sort"].ToString();
		}

		/// <summary>
		/// Given the old sort value and the new sort value, will return 
		/// the new sort, alternating ascending and descending if the same 
		/// column is chosen.  Defaults to ascending on new column sort.
		/// </summary>
		/// <param name="newSort">The new sort column, typically retrieved from SortCommandEventArgs.</param>
		/// <param name="oldSort">The old sort value.</param>
		/// <returns>New sort expression including appropriate sort direction.</returns>
		private string GetNewSort(string newSort, string oldSort)
		{
			// spaceIdx is used to get the sort column from the old sort expression,
			// which will typically contain the sort column followed by a space and 
			// a sort direction (ASC or DESC)
			int spaceIdx = oldSort.IndexOf(" ");
			// if there is no space, add the sort direction, which will by default be ASC
			if (spaceIdx < 0)
			{
				oldSort += " ASC";
				spaceIdx = oldSort.IndexOf(" ");
			}

			if (newSort.Trim() == oldSort.Substring(0, spaceIdx).Trim())
			{
				if (oldSort.IndexOf("ASC") >= 0)
					newSort += " DESC";
				else
					newSort += " ASC";
			}
			else
				newSort += " ASC";

			return newSort;
		}


		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.DataGrid1.SortCommand += new System.Web.UI.WebControls.DataGridSortCommandEventHandler(this.DataGrid1_SortCommand);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void DataGrid1_SortCommand(object source, System.Web.UI.WebControls.DataGridSortCommandEventArgs e)
		{
			ViewState["DataGrid1Sort"] = GetNewSort(e.SortExpression, ViewState["DataGrid1Sort"].ToString());
			this.BindGrid();
		}
	}
}
